; ---------------------------------------------------------------------------
; Copperlist containing VBI area and preview screen
; ---------------------------------------------------------------------------
copperlist:
		; -------------------------------------------------------------------
		; Turn bitplanes off, first thing (variable VBL disables vertical DIW limits)
		; -------------------------------------------------------------------
bplcon_a:	dc.w	$0100,$0204		; $4 = interlace
		dc.w	$0180,$0000
		; -------------------------------------------------------------------
		; Request copper interrupt
		; -------------------------------------------------------------------
		dc.w	$009c,$8010
		; -------------------------------------------------------------------
		; Bitplane settings
		; -------------------------------------------------------------------
txtbpls:	dc.w	$00e0,$0000,$00e2,$0000
		dc.w	$00e4,$0000,$00e6,$0000
		dc.w	$0108,4+HIRES_WB	; BPL1MOD
		dc.w	$010a,4+HIRES_WB	; BPL2MOD
		; -------------------------------------------------------------------
		; Set sprites to zero
		; -------------------------------------------------------------------
coppersprites:	dc.w	$0120,$0000,$0122,$0000
		dc.w	$0124,$0000,$0126,$0000
		dc.w	$0128,$0000,$012a,$0000
		dc.w	$012c,$0000,$012e,$0000
		dc.w	$0130,$0000,$0132,$0000
		dc.w	$0134,$0000,$0136,$0000
		dc.w	$0138,$0000,$013a,$0000
		dc.w	$013c,$0000,$013e,$0000
		; -------------------------------------------------------------------
		; Teletext display
		; -------------------------------------------------------------------
		dc.w	$008e,$1b61		; DIWSTRT
		dc.w	$0090,$40e1		; DIWSTOP
		dc.w	$0092,$0028		; DDFSTRT
		dc.w	$0094,$00d4		; DDFSTOP
		; -------------------------------------------------------------------
		; BPLCON settings
		; -------------------------------------------------------------------
txtbplcon1:	dc.w	$0102,$0077		; BPLCON1: $77 = maximum right-shift for hires
		dc.w	$0104,$0000		; BPLCON2
		dc.w	$0106,$0c00		; BPLCON3: OCS/AGA-compatibility defaults
		dc.w	$010c,$0011		; BPLCON4: OCS/AGA-compatibility defaults
		dc.w	$01fc,$0000		; FMODE:   OCS/AGA-compatibility defaults
		; -------------------------------------------------------------------
		; BEAMCON settings (variable vertical blank)
		; -------------------------------------------------------------------
		dc.w	$01dc,$1020		; BEAMCON0
txtvbstrt:	dc.w	$01cc,$0137		; VBSTRT
txtvbstop:	dc.w	$01ce,$0008		; VBSTOP
		; -------------------------------------------------------------------
		; Colors
		; -------------------------------------------------------------------
		dc.w	$0180,$0000		; Colors: any bit set should be white
txtcols:	dc.w	$0182,$0aaa		; Teletext spec says 67% white == $aaa?
		dc.w	$0184,$0aaa		; Well, white works...
		dc.w	$0186,$0aaa
		; -------------------------------------------------------------------
		; Teletext display area in vertical blank area
		; -------------------------------------------------------------------
copper_first:	dc.w	TEXT_BPL_ON,$fffe
bplcon_b:	dc.w	$0100,$a204		; 2 bitplanes (even and odd teletext bytes overlaid)
copper_last:	dc.w	TEXT_BPL_OFF,$fffe
bplcon_c:	dc.w	$0100,$0204
		; -------------------------------------------------------------------
		; Repeat Teletext data block for inspection
		; -------------------------------------------------------------------
		dc.w	PREVIEW_BG_ON,$fffe
		dc.w	$0180,$0666
repeat_skip:	dc.w	$0084,$0000,$0086,$0000
repeat_jump:	dc.w	$008a,$0000
txtbpls2:	dc.w	$00e0,$0000,$00e2,$0000
		dc.w	$00e4,$0000,$00e6,$0000
		dc.w	REPEAT_BPL_ON,$fffe
bplcon_d:	dc.w	$0100,$a204
		dc.w	$0180,$0000
		dc.w	REPEAT_BPL_OFF,$fffe
bplcon_e:	dc.w	$0100,$0204
		dc.w	$0180,$0666
		; -------------------------------------------------------------------
		; Preview area
		; -------------------------------------------------------------------
preview_start:	dc.w	$0182,$0ccc
		dc.w	$0184,$0444
		dc.w	$0186,$0ccc
previewbpl:	dc.w	$00e0,$0000,$00e2,$0000
		dc.w	$00e4,$0000,$00e6,$0000
		dc.w	$008e,$1bd1		; DIWSTRT
		dc.w	$0090,$7073		; DIWSTOP
		dc.w	$0092,$0064		; DDFSTRT
		dc.w	$0094,$00a8		; DDFSTOP
		dc.w	$0102,$0010
		dc.w	$0108,$0000
		dc.w	$010a,$0000
		; on
		dc.w	$6001,$fffe
bplcon_f:	dc.w	$0100,$9204
		dc.w	$6101,$fffe
bplcon_g:	dc.w	$0100,$a204
		; off
		dc.w	$6101+144*$100,$fffe
bplcon_h:	dc.w	$0100,$0204
		; -------------------------------------------------------------------
		; Data bitmap dump
		; -------------------------------------------------------------------
dump_skip:	dc.w	$0084,$0000,$0086,$0000
dump_jump:	dc.w	$008a,$0000
		dc.w	DEBUG_DUMP_ON-$0200,$fffe
		dc.w	$008e,$1b61		; DIWSTRT
		dc.w	$0090,$40e1		; DIWSTOP
		dc.w	$0092,$0028		; DDFSTRT
		dc.w	$0094,$00d4		; DDFSTOP
		dc.w	$0102,$0077
debugdumppls:	dc.w	$00e0,$0000,$00e2,$0000
		dc.w	$00e4,$0000,$00e6,$0000
		dc.w	$0108,4+HIRES_WB	; BPL1MOD
		dc.w	$010a,4+HIRES_WB	; BPL2MOD
		dc.w	$0182,$0fcc
		dc.w	$0184,$0cfc
		dc.w	$0186,$0f00
		dc.w	DEBUG_DUMP_ON,$fffe
		dc.w	$0180,$0444
bplcon_i:	dc.w	$0100,$a204
		dc.w	$ffdf,$fffe
		dc.w	DEBUG_DUMP_OFF,$fffe
		dc.w	$0180,$0666
bplcon_j:	dc.w	$0100,$0204
		dc.w	PREVIEW_BG_OFF,$fffe
		dc.w	$0180,$0000
		dc.w	$ffff,$fffe
		; -------------------------------------------------------------------
		; Background back to black
		; -------------------------------------------------------------------
back2black:	dc.w	$ffdf,$fffe
		dc.w	PREVIEW_BG_OFF,$fffe
		dc.w	$0180,$0000
		dc.w	$ffff,$fffe
; ---------------------------------------------------------------------------

chipzero:	dc.l	0

preview_area:	ds.b	40*6*24+40			; extra line for shadow

data_bitmap_a:	ds.b	DISPLAY_ROWS*2*HIRES_WB*2	; 2 half-pages, 2 bitplanes
data_bitmap_b:	ds.b	DISPLAY_ROWS*2*HIRES_WB*2
		ds.b	HIRES_WB*2*10

