; ----------------------------------------------------------------------------
; Read keyboard, mouse
; ----------------------------------------------------------------------------

readkey:
	moveq	#0,d0
	move.b  $bfec01,d0	; Keypress
	or.b	#$40,$bfee01	; CIACRAF_SPMODE
	not.b   d0
	ror.b   #1,d0		; d0 now contains the raw key

.KBFix 	movem.l d0-d1/a0,-(a7)	; Horizontal raster timing code
	lea     $dff006,a0	; vhposr
	moveq   #3-1,d0		; Wait because handshake min 75us
.w1	move.b  (a0),d1
.w2	cmp.b   (a0),d1		; One line is 63.5us
	beq.b   .w2
 	dbf     d0,.w1		; Min=127us Max=190.5us

	movem.l (a7)+,d0-d1/a0
	and.b	#$ff-($40),$bfee01
	move.b	_lastkey(a5),d1
	cmp.b	d0,d1
	bne.b	.haskey
	moveq	#0,d0
	clr.w	_key(a5)
	rts
.haskey move.b	d0,_lastkey(a5)
	move.b	d0,_key(a5)
	rts

update_mouse:
	move.w	$a(a6),d1	; JOY0DAT
	move.w	d1,d0
	sub.b	_oldhorizcnt(a5),d0
	ext.w	d0
	move.w	d0,_mouse_dx50(a5)
	add.w	d0,_mouse_dx(a5)
	add.w	d0,_mouse_x(a5)
	move.b	d1,_oldhorizcnt(a5)
	lsr.w	#8,d1
	move.b	_oldvertcnt(a5),d0
	move.b	d1,_oldvertcnt(a5)
	sub.b	d0,d1
	ext.w	d1
	move.w	d1,_mouse_dy50(a5)
	add.w	d1,_mouse_dy(a5)
	add.w 	d1,_mouse_y(a5)
	rts

; ----------------------------------------------------------------------------
; Vanilla keys
; ----------------------------------------------------------------------------

VK_ENTER = $43
VK_RETURN = $44
VK_BACKSPACE = $41
VK_SPACE = $40
VK_ESC = $45
VK_UP = $4c
VK_LEFT = $4f
VK_DOWN = $4d
VK_RIGHT = $4e
VK_LSHIFT = $60
VK_RSHIFT = $61
VK_CTRL = $63
VK_LALT = $64
VK_RALT = $65
VK_HELP = $5f
VK_DEL = $46

VK_1 = $01
VK_2 = $02
VK_3 = $03
VK_4 = $04
VK_5 = $05
VK_6 = $06
VK_7 = $07
VK_8 = $08
VK_9 = $09
VK_0 = $0a

VK_Q = $10
VK_W = $11
VK_E = $12
VK_R = $13
VK_T = $14
VK_Y = $15
VK_U = $16
VK_I = $17
VK_O = $18
VK_P = $19

VK_A = $20
VK_S = $21
VK_D = $22
VK_F = $23
VK_G = $24
VK_H = $25
VK_J = $26
VK_K = $27
VK_L = $28

VK_Z = $31
VK_X = $32
VK_C = $33
VK_V = $34
VK_B = $35
VK_N = $36
VK_M = $37

VK_F1 = $50
VK_F2 = $51
VK_F3 = $52
VK_F4 = $53
VK_F5 = $54
VK_F6 = $55
VK_F7 = $56
VK_F8 = $57
VK_F9 = $58
VK_F10= $59
