
	macro DEBUGCOL
	if ENABLE_DEBUGCOL=1
	move #\1,$dff180
	endif
	endm

	macro	DEBUGBREAK
	move.w	#$00ff,$dff096
	move.w	#$3fff,$dff09a
.\@	move.w	.\@col,$dff180
	eor.w	#$111,.\@col
	bra	.\@
.\@col	dc.w	\1
	endm

	macro TXTPOS
\1 = \2*40+\3
	endm

	macro FORMAT_SETTING
	lea	format_hex4(pc),a0
	lea	fmt_args,a1
	move.l	\1,(a1)
	lea	help,a3
	add.w	#\2,a3
	bsr	txtfmt		; txtfmt(a0: string, a1: data, a3: output)
	endm

	macro FORMAT_FOR_TEST
	lea	format_num(pc),a0
	lea	fmt_args,a1
	move.w	\1,(a1)
	lea	testpage,a3
	add.w	#\2,a3
	bsr	txtfmt		; txtfmt(a0: string, a1: data, a3: output)
	endm

	macro CLIP_MINMAX
	cmp.w	#\2,\1
	bge.b	.\@nomi
	move.w	#\2,\1
.\@nomi	cmp.w	#\3,\1
	ble.b	.\@noma
	move.w	#\3,\1
.\@noma
	endm
	macro CLIP_MAX
	cmp.w	#\2,\1
	ble.b	.\@noma
	move.w	#\2,\1
.\@noma
	endm


	macro TASK_WAIT_TICKS
	move.w	#\1-1,d0
.\@w	YIELD
	dbf	d0,.\@w
	endm


	macro TASK_ROLL_UP_FADE
	lea	\1,a3
	moveq	#0,d7
.\@fad	bsr	task_fade_step
	YIELD
	addq	#8,d7
	cmp.w	#(25+12)*8,d7
	blt	.\@fad
	endm

	macro TASK_TEXTPLOT
	bra.b	.\@go
.\@txt	dc.b	\1,0
	even
.\@go	lea	.\@txt(pc),a0
	move.w	#(\2)*40+(\3),d0
	bsr	plot_string
	endm

	macro	DEBUGLOG
	movem.l	d0-a6,-(a7)
	if \#>1
	move.w	\2,fmt_args
	endif
	if \#>2
	move.w	\3,fmt_args+2
	endif
	if \#>3
	move.w	\4,fmt_args+4
	endif
	if \#>4
	move.w	\5,fmt_args+6
	endif
	if \#>5
	move.w	\6,fmt_args+8
	endif
	if \#>6
	move.w	\7,fmt_args+10
	endif
	if \#>7
	move.w	\8,fmt_args+12
	endif
	if \#>8
	move.w	\9,fmt_args+14
	endif
	if \#>9
	move.w	\10,fmt_args+16
	endif
	if \#>10
	move.w	\11,fmt_args+18
	endif
	lea	.\@txt(pc),a0
	lea	fmt_args,a1
	lea	latest_debug_string,a3
	bsr	txtfmt_including_trailing_0		; txtfmt(a0: string, a1: data, a3: output)
	bra.b	.\@go
.\@txt	dc.b	\1,0
	even
.\@go	bsr	debug_append_latest_debug_string
	movem.l	(a7)+,d0-a6
	endm

	macro	DEBUGFAIL
	DEBUGLOG '*******************'
	DEBUGLOG '*** Fatal error ***'
	DEBUGLOG '*******************'
	movem.l	d0-a6,-(a7)
	if \#>1
	move.w	\2,fmt_args
	endif
	if \#>2
	move.w	\3,fmt_args+2
	endif
	if \#>3
	move.w	\4,fmt_args+4
	endif
	if \#>4
	move.w	\5,fmt_args+6
	endif
	if \#>5
	move.w	\6,fmt_args+8
	endif
	if \#>6
	move.w	\7,fmt_args+10
	endif
	lea	.\@txt(pc),a0
	lea	fmt_args,a1
	lea	latest_debug_string,a3
	bsr	txtfmt_including_trailing_0		; txtfmt(a0: string, a1: data, a3: output)
	bra.b	.\@go
.\@txt	dc.b	\1,0
	even
.\@go	bsr	debug_append_latest_debug_string
	move.l	_txt_renderer(a5),_stashed_renderer(a5)
	move.l	#debug_log_renderer,_txt_renderer(a5)
	movem.l	(a7)+,d0-a6
	endm

	macro	SAVERESTORE
	movem.l	\1,-(a7)
	pea	.\@restore(pc)
	bra.b	.\@go
.\@restore
	movem.l	(a7)+,\1
	rts
.\@go
	endm

	macro ABSDIST_SUB
	sub.w	\1,\2
	bge.b	.\@ispos
	neg.w	\2
.\@ispos
	endm

