; ---------------------------------------------------------------------------
; Cycle through different test pages
; ---------------------------------------------------------------------------

page_renderers:
	dc.l	render_startscreen
	dc.l	render_helpscreen
	dc.l	render_keys
	dc.l	render_animated_testpage
	dc.l	render_flickertest
NUM_RENDERERS=(*-page_renderers)/4

testpage_init:
	DEBUGLOG 'Testpage init'
	bsr	chipset_detect
	rts

testpage_renderer:
	bsr	testpage_handle_keys
	; delegate
	lea	page_renderers,a0
	add.w	_current_testpage(a5),a0
	move.l	(a0),a0
	jmp	(a0)

; ---------------------------------------------------------------------------
; Start screen - animate clock?
; ---------------------------------------------------------------------------
render_startscreen:
	move.l	#startscreen,_txt_page(a5)

	moveq	#0,d0
	move.w	_ticks(a5),d0
	divu	#50,d0
	ext.l	d0
	divu	#60,d0
	move.w	d0,d1
	swap	d0

	lea	format_clock(pc),a0
	lea	fmt_args,a1
	move.w	d1,(a1)
	move.w	d0,2(a1)
	lea	startscreen+35,a3
	bsr	txtfmt

	rts

format_clock:
	dc.b	'%02d:%02d',0
	even

; ---------------------------------------------------------------------------
; Epilepsy warning!
; ---------------------------------------------------------------------------

render_flickertest:
	lea	flickertest,a1
	move.l	a1,_txt_page(a5)
	move.w	_ticks(a5),d0
	and.l	#$fff,d0
	divu	#7,d0
	swap	d0
	addq.w	#1,d0
	add.w	#$10,d0
	move.w	#24-1,d1
	add.w	#23,a1
.flick	move.b	d0,(a1)
	add.w	#40,a1
	dbf	d1,.flick

	move.w	_ticks(a5),d0
	lsr.w	#1,d0
	and.w	#7,d0
	lsl.w	#3,d0
	lea	flickabc(pc),a0
	add.w	d0,a0
	move.l	(a0),d1
	move.l	4(a0),d2
	lea	flickertest+4+40,a1
	move.w	#23-1,d0
.abc	move.l	d1,(a1)
	move.l	d2,4(a1)
	add.w	#40,a1
	dbf	d0,.abc
	rts

flickabc:
	dc.b	'A       '
	dc.b	' B      '
	dc.b	'  C     '
	dc.b	'   D    '
	dc.b	'    E   '
	dc.b	'     F  '
	dc.b	'      G '
	dc.b	'       H'

; ---------------------------------------------------------------------------
; Keys and magazine info
; ---------------------------------------------------------------------------
	TXTPOS PAGENUM_POS,13,20
	TXTPOS FILLNUM_POS,14,20
	TXTPOS SLOWDOWN_POS,16,23

render_keys:
	move.l	#keys,_txt_page(a5)

	lea	format_hex3(pc),a0
	lea	fmt_args,a1
	move.w	_txt_page_mag(a5),d0	; YYYYYMMM
	and.w	#%111,d0
	move.w	d0,(a1)
	move.w	#$00,2(a1)
	lea	keys+PAGENUM_POS,a3
	bsr	txtfmt

	lea	format_hex3(pc),a0
	lea	fmt_args,a1
	move.w	_txt_filler_mag(a5),d0	; YYYYYMMM
	and.w	#%111,d0
	move.w	d0,(a1)
	move.w	#$ff,2(a1)
	lea	keys+FILLNUM_POS,a3
	bsr	txtfmt

	lea	format_digit(pc),a0
	lea	fmt_args,a1
	move.w	_txt_slowdown(a5),(a1)
	lea	keys+SLOWDOWN_POS,a3
	bsr	txtfmt

	rts

format_hex3:
	dc.b	'%x%02x',0
format_digit:
	dc.b	'%d',0
	even

; ---------------------------------------------------------------------------
; Help screen - chipset info and debug keys
; ---------------------------------------------------------------------------
	; Coordinates in help screen
	;
 	; Y,X because that's how https://zxnet.co.uk/teletext/editor/ displays them :)
 	;
	TXTPOS CHIPSET_POS,10,17
	TXTPOS INTERLACE_POS,14,29
	TXTPOS DISPLAY_START_POS,15,29
	TXTPOS DISPLAY_STOP_POS,16,29
	TXTPOS VBI_START_POS,17,29
	TXTPOS VBI_STOP_POS,18,29
	TXTPOS HSHIFT_POS,19,29
	TXTPOS WHITE_POS,20,29
	TXTPOS LASTKEY_POS,0,30
	TXTPOS TICKS_POS,0,34
	TXTPOS LOFADD_POS,21,12
	TXTPOS DYNVBI_POS,21,37
	TXTPOS LOGVBI_POS,22,37
render_helpscreen:
	move.l	#help,_txt_page(a5)
	FORMAT_SETTING bplcon_b,INTERLACE_POS
	FORMAT_SETTING copper_first,DISPLAY_START_POS
	FORMAT_SETTING copper_last,DISPLAY_STOP_POS
	FORMAT_SETTING txtvbstrt,VBI_START_POS
	FORMAT_SETTING txtvbstop,VBI_STOP_POS
	FORMAT_SETTING txtbplcon1,HSHIFT_POS
	FORMAT_SETTING txtcols,WHITE_POS

	lea	format_key(pc),a0
	lea	fmt_args,a1
	moveq	#0,d0
	move.b	_lastkey(a5),d0
	move.w	d0,(a1)
	lea	help+LASTKEY_POS,a3
	bsr	txtfmt		; txtfmt(a0: string, a1: data, a3: output)

	lea	format_ticks(pc),a0
	lea	fmt_args,a1
	move.w	_ticks(a5),(a1)
	lea	help+TICKS_POS,a3
	bsr	txtfmt

	move.w	_dyn_vbi(a5),d0
	add.b	#'0',d0
	move.b	d0,help+DYNVBI_POS

	move.w	_log_vbi(a5),d0
	add.b	#'0',d0
	move.b	d0,help+LOGVBI_POS

	rts

format_hex4:
	dc.b	'%04x %04x',0
format_key:
	dc.b	'%02x',0
format_ticks:
	dc.b	'%6d',0
	even

; ----------------------------------------------------------------------------
; Animated test page
; ----------------------------------------------------------------------------
	TXTPOS FPS_POS,6,36
	TXTPOS FRAME_POS,7,36
	TXTPOS TIME_POS,8,36
	TXTPOS ABC_POS,17,25
	TXTPOS DOT_POS,22,2	; incl 22,38
render_animated_testpage:
	lea	testpage,a0
	move.l	#renderbuffer,_txt_page(a5)
	move.l	_txt_page(a5),a1
	bsr	copy_buffer
	move.l	_txt_page(a5),a0

	; scrolling ABC
	lea	ABC_POS(a0),a1
	move.w	_test_abcpos(a5),d0
	addq.w	#1,_test_abcpos(a5)
	and.w	#31,d0
	lea	abctext(pc),a0
	add.w	d0,a0
	move.w	#15-1,d1
.abc	move.b	(a0)+,(a1)+
	dbf	d1,.abc

	; moving dot
	move.w	_test_botpos(a5),d0
	addq	#1,d0
	cmp.w	#37,d0
	blt.b	.noroll
	moveq	#0,d0
.noroll	move.w	d0,_test_botpos(a5)
	lea	bottext(pc),a0
	move.l	_txt_page(a5),a1
	add.w	#DOT_POS,a1
	clr.w	d1
.bot	move.b	(a0)+,d2
	cmp.w	d0,d1
	beq.b	.isbot
	move.b	#' ',d2
.isbot	move.b	d2,(a1)+
	addq	#1,d1
	cmp.w	#37,d1
	blt.b	.bot

	; counters
	move.w	_test_frame(a5),d0
	addq.w	#1,_test_frame(a5)
	FORMAT_FOR_TEST d0,FRAME_POS

	; fps
	move.w	#2500,d0
	tst.w	_txt_slowdown(a5)
	beq.b	.fps_go
	move.w	#1205,d0
	cmp.w	#1,_txt_slowdown(a5)
	beq.b	.fps_go
	move.w	#803,d0
	cmp.w	#2,_txt_slowdown(a5)
	beq.b	.fps_go
	move.w	#603,d0
	cmp.w	#3,_txt_slowdown(a5)
	beq.b	.fps_go
	move.w	#500,d0
.fps_go	FORMAT_FOR_TEST d0,FPS_POS
	move.b	#'.',testpage+FPS_POS+2

	; coords
	; 2..20  7..18
POINTY_SHIFT=2

POINTY_W=(6*2)
POINTY_H=(5*3)

POINTY_MINX=(1*2)<<POINTY_SHIFT
POINTY_MAXX=(22*2-POINTY_W+1)<<POINTY_SHIFT

POINTY_MINY=(5*3)<<POINTY_SHIFT
POINTY_MAXY=(24*3-POINTY_H+1)<<POINTY_SHIFT
	move.w	_test_px(a5),d0
	move.w	_test_py(a5),d1
	add.w	_mouse_dx(a5),d0
	add.w	_mouse_dy(a5),d1
	CLIP_MINMAX d0,POINTY_MINX,POINTY_MAXX
	CLIP_MINMAX d1,POINTY_MINY,POINTY_MAXY
	move.w	d0,_test_px(a5)
	move.w	d1,_test_py(a5)

	lsr.w	#POINTY_SHIFT,d0
	lsr.w	#POINTY_SHIFT,d1

	lea	pointy,a0
	move.l	_txt_page(a5),a1
	move.w	#$10+COL1_RED,d2
	bsr	draw_sixel_sprite	; draw_sixel_sprite(a0: sprite, a1: buf, d0: x, d1: y, d2: color or -1)

	rts

format_num:	dc.b '%4d',0
abctext:	;    [##########..........##########..]
		dc.b 'abcdefghijklmnopqrstuvwxyz ++++ '
		dc.b 'abcdefghijklmnopqrstuvwxyz ++++ '
bottext:	;    [##########..........##########.......]
		dc.b ',#,p0,#,p0,#,p0,#,p0,#,p0,#,p0,#,p0,#,'
		even


; ----------------------------------------------------------------------------
; Keyboard handler
; ----------------------------------------------------------------------------

	macro IFKEY
	cmp.b	#\1,d0
	beq	\2
	endm

testpage_handle_keys
	move.b	_key(a5),d0
	IFKEY	VK_SPACE,.on_next
	IFKEY	VK_ESC,.on_esc
	IFKEY	VK_F1,.pagemag
	IFKEY	VK_F2,.fillmag
	IFKEY	VK_F7,.debuglog
	IFKEY	VK_F,.first_up
	IFKEY	VK_G,.first_down
	IFKEY	VK_V,.last_up
	IFKEY	VK_B,.last_down
	IFKEY	VK_H,.vblstrt_up
	IFKEY	VK_J,.vblstrt_down
	IFKEY	VK_N,.vblstop_up
	IFKEY	VK_M,.vblstop_down
	IFKEY	VK_X,.left
	IFKEY	VK_C,.right
	IFKEY	VK_P,.toggle_white
	IFKEY	VK_I,.toggle_interlace
	IFKEY	VK_T,.toggle_preview
	IFKEY	VK_D,.toggle_debug_time
	IFKEY	VK_K,.toggle_debug_font
	IFKEY	VK_E,.skip_frame
	IFKEY	VK_Q,.toggle_dynvbi
	IFKEY	VK_R,.toggle_logvbi
	IFKEY	VK_S,.toggle_slowdown
	rts
.toggle_slowdown
	move.w	_txt_slowdown(a5),d0
	addq.w	#1,d0
	cmp.w	#4,d0
	ble.b	.no_sd_roll
	moveq	#0,d0
.no_sd_roll
	move.w	d0,_txt_slowdown(a5)
	DEBUGLOG 'FPS slowdown set to %d',d0
	rts
.toggle_dynvbi
	bchg	#0,_dyn_vbi+1(a5)
	DEBUGLOG 'Dynamic VBSTRT set to %d',_dyn_vbi(a5)
	rts
.toggle_logvbi
	bchg	#0,_log_vbi+1(a5)
	DEBUGLOG 'VBI logging set to %d',_log_vbi(a5)
	rts
.pagemag
	move.w	_txt_page_mag(a5),d0
	addq.w	#1,d0
	and.w	#%111,d0
	move.w	d0,_txt_page_mag(a5)
	rts
.fillmag
	move.w	_txt_filler_mag(a5),d0
	addq.w	#1,d0
	and.w	#%111,d0
	move.w	d0,_txt_filler_mag(a5)
	rts
.on_next
	move.w	_current_testpage(a5),d0
	addq	#4,d0
	cmp.w	#NUM_RENDERERS*4,d0
	blt.b	.flipped
	moveq	#0,d0
.flipped
	move.w	d0,_current_testpage(a5)
	rts
.debuglog
	move.l	_txt_renderer(a5),_stashed_renderer(a5)
	move.l	#debug_log_renderer,_txt_renderer(a5)
	rts
.on_esc
	clr.w	_running(a5)
	rts
.first_up
	sub.w	#$0100,copper_first
	rts
.first_down
	add.w	#$0100,copper_first
	rts
.last_up
	sub.w	#$0100,copper_last
	rts
.last_down
	add.w	#$0100,copper_last
	rts
.vblstrt_up
	sub.w	#1,txtvbstrt+2
	rts
.vblstrt_down
	add.w	#1,txtvbstrt+2
	rts
.vblstop_up
	sub.w	#1,txtvbstop+2
	rts
.vblstop_down
	add.w	#1,txtvbstop+2
	rts
.left
	move.w	txtbplcon1+2,d0
	sub.w	#$11,d0
	bra.b	.sethshift
.right
	move.w	txtbplcon1+2,d0
	add.w	#$11,d0
.sethshift
	and.w	#$f,d0
	move.w	d0,d1
	lsl.w	#4,d1
	or.w	d1,d0
	move.w	d0,txtbplcon1+2
	rts
.toggle_white
	move.w	txtcols+2,d0
	beq.b	.tw_was0
	sub.w	#$111,d0
	bra.b	.tw_set
.tw_was0
	move.w	#$fff,d0
.tw_set
	move.w	d0,txtcols+2
	move.w	d0,txtcols+2+4
	move.w	d0,txtcols+2+8
	rts
.toggle_interlace
	btst	#2,bplcon_a+3
	beq.b	.set_interlace
	bclr	#2,bplcon_a+3		; LACE
	bclr	#2,bplcon_b+3
	bclr	#2,bplcon_c+3
	bclr	#2,bplcon_e+3
	bclr	#2,bplcon_f+3
	bclr	#2,bplcon_g+3
	bclr	#2,bplcon_h+3
	bclr	#2,bplcon_i+3
	bclr	#2,bplcon_j+3
	rts
.set_interlace
	bset	#2,bplcon_a+3		; LACE
	bset	#2,bplcon_b+3
	bset	#2,bplcon_c+3
	bset	#2,bplcon_e+3
	bset	#2,bplcon_f+3
	bset	#2,bplcon_g+3
	bset	#2,bplcon_h+3
	bset	#2,bplcon_i+3
	bset	#2,bplcon_j+3
	rts
.toggle_preview
	cmp.w	#$01fe,repeat_jump	; NOP
	beq.b	.preview_on
	move.w	#$01fe,repeat_jump
	move.w	#$01fe,dump_jump
	rts
.preview_on
	move.w	#$008a,repeat_jump	; COPJMP2
	move.w	#$008a,dump_jump
	rts
.toggle_debug_time
	not.w	_debug_time(a5)
	rts

.toggle_debug_font
	cmp.l	#font_norm,_font(a5)
	beq.b	.to_debug
	move.l	#font_norm,_font(a5)
	move.l	#font_norm+128*8,_fontgfx(a5)
	rts
.to_debug
	move.l	#font_debug,_font(a5)
	move.l	#font_debug+128*8,_fontgfx(a5)
	rts
.skip_frame
	addq.w	#1,_ticks(a5)
	rts

; ----------------------------------------------------------------------------
; Helpers
; ----------------------------------------------------------------------------

; AGA check, Toni Wilen:
; > VPOSR (DFF004) AGA check is easiest and 100% reliable test.
; > No extra tests needed like DENISEID/LISAID required
; https://eab.abime.net/showpost.php?p=934465&postcount=6
;
chipset_detect:
	move.w	$4(a6),d0		; chip ID = (VPOSR & $7f00)>>8
					;
					;      8361 (Regular) or 8370 (Fat) (Agnus-NTSC) = $10
					; OCS: 8367 (Pal) or 8371 (Fat-Pal) (Agnus-PAL)  = $00
					; ECS: 8372 (Fat-hr) (agnushr),thru rev4         = $20 PAL, $30 NTSC
					; ECS: 8372 (Fat-hr) (agnushr),rev 5             = $21 PAL, $31 NTSC
					; AGA: 8374 (Alice) thru rev 2                   = $22 PAL, $32 NTSC
					; AGA: 8374 (Alice) rev 3 thru rev 4             = $23 PAL, $33 NTSC
	lsr.w	#8,d0
	and.w	#%1111111,d0
	DEBUGLOG 'Chipset detect: VPOSR ID = $%02x',d0
	move.w	d0,_chipset_id(a5)
	and.w	#%1101111,d0		; also mask out NTSC bit (won't run anyway)

	lea	.txt_ocs(pc),a0
	tst.w	d0
	beq.b	.cs_done		; $00 = OCS

	lea	.txt_ecs(pc),a0		; ECS?
	cmp.w	#$20,d0
	beq.b	.cs_done
	cmp.w	#$21,d0
	beq.b	.cs_done

	lea	.txt_aga(pc),a0		; AGA?
	cmp.w	#$22,d0
	beq.b	.cs_done
	cmp.w	#$23,d0
	beq.b	.cs_done

	lea	.txt_wtf(pc),a0		; cannot identify
.cs_done
	;
	; Write into help page
	;
	lea	fmt_args,a1
	move.w	_chipset_id(a5),(a1)

	lea	fmt_args,a1
	lea	help,a3
	add.w	#CHIPSET_POS,a3
	bsr	txtfmt		; txtfmt(a0: string, a1: data, a3: output)
	rts

.txt_ocs	dc.b	' VPOSR SAYS OCS? (%02x)',0
.txt_ecs	dc.b	'YOU SEEM TO HAVE ECS.',0
.txt_aga	dc.b	'YOU SEEM TO HAVE AGA.',0
.txt_wtf	dc.b	'HM, WEIRD VPOSR ID %02x',0
		even

